## sunpinyin 2.0.3+git20120607

=== SConstruct ===
import platform
import os
import sys

version="2.0.4"
abi_major = 3
abi_minor = 0

cflags = '-g -Wall'

slmsource = [
    'src/slm/ids2ngram/ids2ngram.cpp',
    'src/slm/ids2ngram/idngram_merge.cpp',
    'src/slm/mmseg/mmseg.cpp',
    'src/slm/tslminfo/tslminfo.cpp',
    'src/slm/tslmpack/arpa_slm.cpp',
    'src/slm/tslmpack/arpa_conv.cpp',
    'src/slm/tslmpack/slmpack.cpp',
    'src/slm/slm.cpp',
    'src/slm/slminfo/slminfo.cpp',
    'src/slm/sim_sen.cpp',
    'src/slm/sim_slm.cpp',
    'src/slm/getWordFreq/getWordFreq.cpp',
    'src/slm/slmseg/slmseg.cpp',
    'src/slm/thread/slmthread.cpp',
    'src/slm/thread/test_vc.cpp',
    'src/slm/thread/ValueCompress.cpp',
    'src/slm/slmbuild/slmbuild.cpp',
    'src/slm/slmprune/slmprune.cpp',
    'src/slm/sim_slmbuilder.cpp',
    'src/slm/tslmendian/slm_endian.cpp',
    'src/slm/tslmendian/writer.cpp',
    'src/slm/tslmendian/slm_file.cpp',
    'src/slm/sim_dict.cpp',
    'src/portability.cpp',
    'src/lexicon/trie_writer.cpp',
    'src/lexicon/genPYT.cpp',
    'src/lexicon/pytrie_gen.cpp',
    'src/lexicon/pytrie.cpp',
    'src/pinyin/pinyin_data.cpp',
    ]

imesource = [
    'src/portability.cpp',
    'src/slm/slm.cpp',
    'src/lexicon/pytrie.cpp',
    'src/pinyin/pinyin_data.cpp',
    'src/pinyin/pinyin_seg.cpp',
    'src/pinyin/shuangpin_data.cpp',
    'src/pinyin/shuangpin_seg.cpp',
    'src/pinyin/hunpin_seg.cpp',
    'src/ime-core/imi_context.cpp',
    'src/ime-core/imi_data.cpp',
    'src/ime-core/lattice_states.cpp',
    'src/ime-core/imi_view.cpp',
    'src/ime-core/imi_uiobjects.cpp',
    'src/ime-core/imi_view_classic.cpp',
    'src/ime-core/imi_winHandler.cpp',
    'src/ime-core/ic_history.cpp',
    'src/ime-core/imi_funcobjs.cpp',
    'src/ime-core/imi_options.cpp',
    'src/ime-core/imi_option_event.cpp',
    'src/ime-core/userdict.cpp',
    ]

headers = [
    'src/slm/ids2ngram/idngram.h',
    'src/slm/ids2ngram/idngram_merge.h',
    'src/slm/slm.h',
    'src/slm/tslmpack/arpa_slm.h',
    'src/slm/tslmpack/common.h',
    'src/slm/tslmpack/arpa_conv.h',
    'src/slm/sim_dict.h',
    'src/slm/sim_sen.h',
    'src/slm/sim_slm.h',
    'src/slm/thread/ValueCompress.h',
    'src/slm/sim_fmerge.h',
    'src/slm/sim_slmbuilder.h',
    'src/slm/tslmendian/slm_file.h',
    'src/slm/tslmendian/writer.h',
    'src/lexicon/pytrie_gen.h',
    'src/lexicon/trie_writer.h',
    'src/lexicon/pytrie.h',
    'src/ime-core/imi_view_classic.h',
    'src/ime-core/imi_uiobjects.h',
    'src/ime-core/lattice_states.h',
    'src/ime-core/ic_history.h',
    'src/ime-core/imi_funcobjs.h',
    'src/ime-core/imi_context.h',
    'src/ime-core/imi_winHandler.h',
    'src/ime-core/imi_glibHandler.h',
    'src/ime-core/userdict.h',
    'src/ime-core/imi_option_event.h',
    'src/ime-core/imi_data.h',
    'src/ime-core/utils.h',
    'src/ime-core/imi_keys.h',
    'src/ime-core/imi_option_keys.h',
    'src/ime-core/imi_options.h',
    'src/ime-core/imi_defines.h',
    'src/ime-core/imi_view.h',
    'src/portability.h',
    'src/pinyin/segmentor.h',
    'src/pinyin/shuangpin_seg.h',
    'src/pinyin/datrie.h',
    'src/pinyin/quanpin_trie.h',
    'src/pinyin/pinyin_seg.h',
    'src/pinyin/pinyin_data.h',
    'src/pinyin/syllable.h',
    'src/pinyin/shuangpin_data.h',
    'src/pinyin/hunpin_seg.h',
    'src/pinyin/datrie_impl.h',
    'src/sunpinyin.h',
    ]

# source of plugin module, it's off by default
# and this module depends on Python
imesource_plugin = [
    'src/ime-core/imi_plugin.cpp',
    ]

headers_plugin = [
    'src/ime-core/imi_plugin.h',
    ]

# options
AddOption('--prefix', dest='prefix', metavar='DIR',
          help='installation prefix')

AddOption('--libdir', dest='libdir', metavar='DIR',
          help='installation libdir')

AddOption('--libdatadir', dest='libdatadir', metavar='DIR',
          help='installation libdata dir')

AddOption('--rpath', dest='rpath', metavar='DIR',
          help='encode rpath in the executables')

AddOption('--enable-plugins', dest='enable_plugins', action='store_true',
          default=False, help='enable plugin mechanism at libsunpinyin layer')

AddOption('--disable-plugins', dest='enable_plugins', action='store_false',
          default=False, help='disable plugin mechanism at libsunpinyin layer')

# save the options
opts = Variables('configure.conf')
opts.Add('PREFIX', default='/usr/local')
opts.Add('LIBDIR', default='/usr/local/lib')
opts.Add('LIBDATADIR', default='/usr/local/lib')
opts.Add('ENABLE_PLUGINS', default=False)

#
#==============================environment==============================
#
#
def allinc():
    inc=[]
    for root, dirs, files in os.walk('src'):
        inc.append(root)
    return inc

def GetOS():
    return platform.uname()[0]

def CreateEnvironment():
    tar = 'tar'
    make = 'make'
    wget = 'wget'
    if GetOS() == 'Darwin':
        wget = 'curl -O'
    elif GetOS() == 'FreeBSD':
        wget = 'fetch'
        make = 'gmake'
    elif GetOS() == 'SunOS':
        tar = 'gtar'
        make = 'gmake'

    libln_builder = Builder(action='ln -s ${SOURCE.name} ${TARGET.name}',
                            chdir=True)
    env = Environment(ENV=os.environ, CFLAGS=cflags, CXXFLAGS=cflags,
                      TAR=tar, MAKE=make, WGET=wget,
                      CPPPATH=['.'] + allinc(),
                      tools=['default', 'textfile'])
    env.Append(BUILDERS={'InstallAsSymlink': libln_builder})
    return env

def PassVariables(envvar, env):
    for (x, y) in envvar:
        if x in os.environ:
            print 'Warning: you\'ve set %s in the environmental variable!' % x
            env[y] = os.environ[x]

env = CreateEnvironment()
opts.Update(env)

if GetOption('prefix') is not None:
    env['PREFIX'] = GetOption('prefix')
    env['LIBDATADIR'] = os.path.join(env['PREFIX'], 'lib')
    env['LIBDIR'] = os.path.join(env['PREFIX'], 'lib')

if GetOption('libdir') is not None:
    env['LIBDIR'] = GetOption('libdir')

if GetOption('libdatadir') is not None:
    env['LIBDATADIR'] = GetOption('libdatadir')

env['ENABLE_PLUGINS'] = GetOption('enable_plugins')

opts.Save('configure.conf', env)

libdir = env['LIBDIR']
libdatadir = os.path.join(env['LIBDATADIR'], 'sunpinyin/data')
headersdir = os.path.join(env['PREFIX'], 'include/sunpinyin-2.0')

# pass through environmental variables
envvar = [('CC', 'CC'),
          ('CXX', 'CXX'),
          ('CFLAGS', 'CFLAGS'),
          ('CXXFLAGS', 'CXXFLAGS'),
          ('LDFLAGS', 'LINKFLAGS'),
          ('TAR', 'TAR'),
          ('MAKE', 'MAKE'),
          ('WGET', 'WGET')]
PassVariables(envvar, env)

# append the source and headers
if env['ENABLE_PLUGINS']:
    imesource += imesource_plugin
    headers += headers_plugin

# merge some of critical compile flags
env.MergeFlags(['-pipe -DHAVE_CONFIG_H',
                '-DSUNPINYIN_DATA_DIR=\\\'\\"%s\\"\\\'' % libdatadir])

if GetOption('rpath') is not None and GetOS() != 'Darwin':
    env.MergeFlags('-Wl,-R -Wl,%s' % GetOption('rpath'))

#
#==============================configure================================
#
def CheckPKGConfig(context, version='0.12.0'):
    context.Message('Checking for pkg-config... ')
    ret = context.TryAction('pkg-config --atleast-pkgconfig-version=%s' % version)[0]
    context.Result(ret)
    return ret

def CheckPKG(context, name):
    context.Message('Checking for %s... ' % name)
    ret = context.TryAction('pkg-config --exists \'%s\'' % name)[0]
    context.Result(ret)
    return ret

def CheckPython(context):
    context.Message('Checking for Python library...')
    ret = context.TryAction('python-config --prefix')[0]
    context.Result(ret)
    if ret:
        context.env.MergeFlags(['!python-config --includes',
                                '!python-config --libs'])
    return ret

def AppendEndianCheck(conf):
    conf.config_h_text += r'''

#if defined(_BIG_ENDIAN) && !defined(_LITTLE_ENDIAN)
# define WORDS_BIGENDIAN 1

#elif defined(_LITTLE_ENDIAN) && !defined(_BIG_ENDIAN)
# undef WORDS_BIGENDIAN

#elif defined(__sparc) || defined(__sparc__) \
  || defined(_POWER)   || defined(__powerpc__) \
  || defined(__ppc__)  || defined(__hpux) || defined(__hppa) \
  || defined(_MIPSEB)  || defined(_POWER) \
  || defined(__s390__) || (defined(__sh__) && defined(__BIG_ENDIAN__))
# define WORDS_BIGENDIAN 1

#elif defined(__i386__) || defined(__i386) \
  || defined(__ia64)    || defined(__ia64__) \
  || defined(_M_IX86)   || defined(_M_IA64) \
  || defined(_M_ALPHA)  || defined(__amd64) \
  || defined(__amd64__) || defined(_M_AMD64) \
  || defined(__x86_64)  || defined(__x86_64__) \
  || defined(_M_X64)    || defined(__bfin__) \
  || defined(__alpha__) || defined(__ARMEL__) \
  || defined(_MIPSEL)   || (defined(__sh__) && defined(__LITTLE_ENDIAN__))
# undef WORDS_BIGENDIAN

#else
# error can not detect the endianness!
#endif
'''

conf = env.Configure(clean=False, help=False, config_h='config.h',
                     custom_tests={'CheckPKGConfig' : CheckPKGConfig,
                                   'CheckPKG' : CheckPKG,
                                   'CheckPython': CheckPython})

def DoConfigure():
    if GetOS() == 'Darwin':
        if not conf.CheckLibWithHeader('sqlite3', 'sqlite3.h', 'C'):
            Exit(1)
        if not conf.CheckLibWithHeader('iconv', 'iconv.h', 'C'):
            Exit(1)
    else:
        if not conf.CheckPKGConfig():
            Exit(1)
        if not conf.CheckPKG('sqlite3'):
            Exit(1)

    if conf.env['ENABLE_PLUGINS']:
        if not conf.CheckPython():
            Exit(1)
        conf.Define('ENABLE_PLUGINS')

    conf.Define('ENABLE_NLS', 1)
    conf.Define('GETTEXT_PACKAGE', '"sunpinyin2"')
    conf.CheckCHeader('assert.h')
    conf.CheckFunc('bind_textdomain_codeset')
    conf.CheckFunc('dcgettext')
    conf.CheckCHeader('dlfcn.h')
    conf.CheckFunc('exp2')
    conf.CheckCHeader('fcntl.h')
    conf.CheckCHeader('getopt.h')
    conf.CheckFunc('getopt_long')
    conf.CheckFunc('getpagesize')
    conf.CheckFunc('get_opt')
    conf.CheckCHeader('iconv.h')
    conf.CheckCHeader('inttypes.h')
    conf.CheckCHeader('locale.h')
    conf.CheckCHeader('libintl.h')
    conf.CheckCHeader('limits.h')
    conf.CheckCHeader('locale.h')
    conf.CheckFunc('log2')
    conf.CheckCHeader('memory.h')
    conf.CheckFunc('memset')
    conf.CheckFunc('mmap')
    conf.CheckFunc('munmap')
    conf.CheckFunc('setlocale')
    conf.CheckFunc('strndup')
    conf.CheckCHeader('sys/mman.h')
    conf.CheckCHeader('sys/param.h')
    conf.CheckCHeader('sys/stat.h')
    conf.CheckCHeader('sys/types.h')
    conf.CheckCHeader('unistd.h')
    conf.CheckCHeader('wchar.h')

    # add essential package requirements
    conf.Define('PACKAGE', '"sunpinyin"')
    conf.Define('PACKAGE_NAME', '"sunpinyin"')
    conf.Define('PACKAGE_STRING', '"sunpinyin 2.0"')
    conf.Define('PACKAGE_TARNAME', '"sunpinyin"')
    conf.Define('PACKAGE_VERSION', '"2.0"')
    conf.Define('VRESION', '"2.0"')

    # append endianness checking defines
    AppendEndianCheck(conf)
    env = conf.Finish()
    # generate sunpinyin.pc
    env.Substfile('sunpinyin-2.0.pc.in', SUBST_DICT={
            '@PREFIX@': env['PREFIX'],
            '@LIBDIR@': env['LIBDIR'],
            '@VERSION@': version,
            '@CFLAGS@': reduce(lambda a, b: a + ' ' + b,
                               map(lambda x: '-I$${includedir}' + x[3:],
                                   allinc())),
            })

    if GetOS() != 'Darwin':
        env.ParseConfig('pkg-config sqlite3 --libs --cflags')

if not GetOption('clean') and not GetOption('help'):
    DoConfigure()

#
#==============================compile==============================
#
env.Object(slmsource)

SConscript(['build/SConscript'], exports='env')

libname_default = '%ssunpinyin%s' % (env.subst('${SHLIBPREFIX}'),
                                     env.subst('${SHLIBSUFFIX}'))
libname_link = libname_default
libname_soname = '%s.%d' % (libname_link, abi_major)
libname = '%s.%d' % (libname_soname, abi_minor)
lib = None

=== build/Makefile ===
SLM_SRC_DIR = ../src/slm
LEXICON_SRC_DIR = ../src/lexicon
PINYIN_SRC_DIR = ../src/pinyin

CORPUS_DIR = ../raw
SWAP_DIR = ../swap
RESULT_DIR = ../data

DICTFILE = ${CORPUS_DIR}/dict.utf8
CORPUSFILE = ${CORPUS_DIR}/corpus.utf8
TEST_CORPUSFILE = ${CORPUS_DIR}/test.utf8
REAL_CORPUSFILE = ${CORPUS_DIR}/BIGCORPUS

LMTARGET = lm_sc
IDS_FILE = ${SWAP_DIR}/${LMTARGET}.ids
SWAP_FILE = ${SWAP_DIR}/swap

#FILE NAMES for BIGRAM model
IDNGRAM_FILE = ${SWAP_DIR}/${LMTARGET}.id2gram
RAW_LM_FILE = ${SWAP_DIR}/${LMTARGET}.2gram 
SLM_FILE = ${SWAP_DIR}/${LMTARGET}.2gm 
SLM_INFO_FILE = ${SWAP_DIR}/${LMTARGET}.2gm.arpa 
TSLM_FILE = ${RESULT_DIR}/${LMTARGET}.t2g
TSLM_INFO_FILE = ${SWAP_DIR}/${LMTARGET}.t2g.arpa

#FILE NAMES for TRIGRAM model
IDNGRAM_FILE3 = ${SWAP_DIR}/${LMTARGET}.id3gram
RAW_LM_FILE3 = ${SWAP_DIR}/${LMTARGET}.3gram 
SLM_FILE3 = ${SWAP_DIR}/${LMTARGET}.3gm 
SLM_INFO_FILE3 = ${SWAP_DIR}/${LMTARGET}.3gm.arpa 
TSLM_FILE3 = ${RESULT_DIR}/${LMTARGET}.t3g
TSLM_INFO_FILE3 = ${SWAP_DIR}/${LMTARGET}.t3g.arpa
TSLM_REPACKED_FILE3 = ${SWAP_DIR}/${LMTARGET}.t3g.repacked
TSLM_UNPACKED_FILE3 = ${SWAP_DIR}/${LMTARGET}.t3g.arpa.unpacked

#Lexicon FILE names (raw resource and others)
PINYIN_TEXTFILE = ${CORPUS_DIR}/dict.utf8
PINYIN_NMP_TEXTFILE = ${SWAP_DIR}/dict_nmp.utf8
PYTRIE_FILE = ${RESULT_DIR}/pydict_sc.bin
PYTRIE_PRINTOUT = ${SWAP_DIR}/pydict_sc.log.utf8

test_corpus :
	if [ -e ${CORPUSFILE} ]; then unlink ${CORPUSFILE}; fi
	ln -s ${TEST_CORPUSFILE} ${CORPUSFILE}

real_corpus :
	if [ -e ${CORPUSFILE} ]; then unlink ${CORPUSFILE}; fi
	ln -s ${REAL_CORPUSFILE} ${CORPUSFILE}

ids :
	./mmseg -d ${DICTFILE} -f bin -s 10 -a 9 ${CORPUSFILE} >${IDS_FILE}

slmids3:
	./slmseg -d ${DICTFILE} -f bin -s 10 -m ${TSLM_FILE3} ${CORPUSFILE} >${IDS_FILE}
	cp ${TSLM_FILE3} ${TSLM_FILE3}.normal

slmids:
	./slmseg -d ${DICTFILE} -f bin -s 10 -m ${TSLM_FILE} ${CORPUSFILE} >${IDS_FILE}
	cp ${TSLM_FILE} ${TSLM_FILE}.normal

#second round bootstrap bigram
bs_bigram : slmids m2_idngram m2_slm m2_prune m2_thread m2_tslminfo

#second round bootstrap bigram from a trigram model
bs_bigram3 : slmids3 m2_idngram m2_slm m2_prune m2_thread m2_tslminfo

#This is the command to make a bigram model
bigram : ids m2_idngram m2_slm m2_prune m2_thread m2_tslminfo

m2_idngram : 
	./ids2ngram -n 2 -s ${SWAP_FILE} -o ${IDNGRAM_FILE} -p 20000000 ${IDS_FILE}
	rm -f ${SWAP_FILE}

m2_slm:	
	./slmbuild -n 2 -o ${RAW_LM_FILE} -w 200000 -c 0,2 -d ABS,0.005 -d ABS -b 10 -e 9 ${IDNGRAM_FILE}

m2_prune: 
	./slmprune ${RAW_LM_FILE} ${SLM_FILE} R 100000 200000

m2_thread :
	./slmthread ${SLM_FILE} ${TSLM_FILE}

m2_tslminfo :
	./tslminfo -v -l ${DICTFILE} ${TSLM_FILE} >${TSLM_INFO_FILE}

#Use this to generate bigram non-threaded lm arpa information if needed
m2_info :
	./slminfo -p -v -l ${DICTFILE} ${SLM_FILE} >${SLM_INFO_FILE}

#second round bootstrap to make trigram model
bs_trigram : slmids3 m3_idngram m3_slm m3_prune m3_thread m3_tslminfo

#This is the command to make a trigram model
trigram : ids m3_idngram m3_slm m3_prune m3_thread m3_tslminfo

m3_idngram : 
	./ids2ngram -n 3 -s ${SWAP_FILE} -o ${IDNGRAM_FILE3} -p 20000000 ${IDS_FILE}
	rm -f ${SWAP_FILE}

m3_slm:	
	./slmbuild -n 3 -o ${RAW_LM_FILE3} -w 200000 -c 0,2,2 -d ABS,0.0005 -d ABS -d ABS -b 10 -e 9 ${IDNGRAM_FILE3}

m3_prune: 
	./slmprune ${RAW_LM_FILE3} ${SLM_FILE3} R 100000 2500000 1000000

m3_thread :
	./slmthread ${SLM_FILE3} ${TSLM_FILE3}

m3_tslminfo :
	./tslminfo -p -v -l ${DICTFILE} ${TSLM_FILE3} >${TSLM_INFO_FILE3}

m3_tslmpack :
	./tslmpack ${TSLM_INFO_FILE3} ${DICTFILE} ${TSLM_REPACKED_FILE3}

m3_tslmunpack :
	./tslminfo -p -v -l ${DICTFILE} ${TSLM_REPACKED_FILE3} >${TSLM_UNPACKED_FILE3}

#Use this to generate trigram non-threaded lm arpa information if needed
m3_info :
	./slminfo -p -v -l ${DICTFILE} ${SLM_FILE3} >${SLM_INFO_FILE3}

#clean all intermedian file for building the model
model_clean :
	rm -f ${IDS_FILE}
	rm -f ${SWAP_FILE}
	rm -f ${IDNGRAM_FILE} ${RAW_LM_FILE}
	rm -f ${IDNGRAM_FILE3} ${RAW_LM_FILE3}

lexicon :
	./genpyt -i ${PINYIN_TEXTFILE} -o ${PYTRIE_FILE} -l ${PYTRIE_PRINTOUT} -s ${TSLM_FILE3}

lexicon2 :
	./genpyt -i ${PINYIN_TEXTFILE} -o ${PYTRIE_FILE} -l ${PYTRIE_PRINTOUT} -s ${TSLM_FILE}

=== raw/Makefile ===
LM_URL=http://open-gram.googlecode.com/files
WGET=wget
TAR=tar

all: lm_sc.t3g.arpa dict.utf8
	@echo done

lm_sc.t3g.arpa: stamp-lm

stamp-lm: lm_sc.t3g.arpa.tar.bz2
	$(TAR) -jxf $^
	touch $@

lm_sc.t3g.arpa.tar.bz2:
	$(WGET) $(LM_URL)/$@

dict.utf8: stamp-dict

stamp-dict: dict.utf8.tar.bz2
	$(TAR) -jxf $^
	touch $@

dict.utf8.tar.bz2:
	$(WGET) $(LM_URL)/$@

clean:
	@rm -f stamp-dict stamp-lm lm_sc.t3g.arpa dict.utf8
	@echo cleaned

=== debian/changelog ===
sunpinyin (2.0.3+git20120607-1) unstable; urgency=low

  * New upstream snapshot 20120607.

 -- YunQiang Su <wzssyqa@gmail.com>  Sat, 09 Jun 2012 16:40:36 +0800

sunpinyin (2.0.3+git20120404-1) unstable; urgency=low

  * New upstream commit: fix FTBFS with gcc-4.7 (Closes: #667385).
  * Add Multi-Arch: same to libsunpinyin3, -dev and -dbg.
  * Add YunQiang Su to uploaders.

 -- YunQiang Su <wzssyqa@gmail.com>  Wed, 11 Apr 2012 03:06:40 +0800

sunpinyin (2.0.3+git20120222-2) unstable; urgency=low

  [ debian/patches/unistd_h_determine_macro.patch ]
    * include unistd.h if it exists, not only when "sun" defined.
      (Closes: #667385)

 -- YunQiang Su <wzssyqa@gmail.com>  Wed, 04 Apr 2012 17:16:10 +0800

sunpinyin (2.0.3+git20120222-1) unstable; urgency=low

  * Team upload: git snapshot 20120222.
     - fix breaks if LDFLAGS in environment contains
         multiple words (Closese #646001).
     - rm patches merged to upstream:
         append-os-environ-toenv.patch
         fix-ftbfs-on-sh.patch
         remove-10-candidate-words-limitation.patch
     - refresh disable-lm-dict-compile.patch.
  * Bump stardard version to 3.9.3: no modify needed.
  * add libsunpinyin3-dbg and python-sunpinyin packages.
  * debian/compat to 9, multiarch it.
  * rewrite debian/rules with dh 7 format.
  
 -- YunQiang Su <wzssyqa@gmail.com>  Fri, 30 Mar 2012 15:31:55 +0800

sunpinyin (2.0.3-5) unstable; urgency=low

  * Call dh_makeshlibs with -V, rather than dh_shlibdeps

 -- Liang Guo <bluestonechina@gmail.com>  Wed, 05 Oct 2011 02:52:25 +0800

sunpinyin (2.0.3-4) unstable; urgency=low

  * Update Format field in debian/copyright
  * Add Upstream-Contact in debian/copyright
  * Add DM-Upload-Allowed in debian/control
  * remove 10 candidate words limitation

 -- Liang Guo <bluestonechina@gmail.com>  Tue, 27 Sep 2011 21:50:42 +0800

sunpinyin (2.0.3-3) unstable; urgency=low

  * Call dh_makeshlibs with -V (Close: #632355)
  * Bump Standards-Version to 3.9.2
  * Add build-arch and build-indep in debian/rules
  * Update debian/copyright to fit DEP-5
  * Move git repository from collab-maint to pkg-ime,
    Update Vcs-* fields in debian/control

 -- Liang Guo <bluestonechina@gmail.com>  Thu, 08 Sep 2011 23:13:01 +0800

=== debian/control ===
Source: sunpinyin
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Liang Guo <bluestonechina@gmail.com>, YunQiang Su <wzssyqa@gmail.com>
Build-Depends: debhelper (>= 9), scons, libsqlite3-dev, pkg-config, 
		quilt (>= 0.46-8~), python-dev (>= 2.6.6-3~)
Standards-Version: 3.9.3
Section: libs
DM-Upload-Allowed: yes
Homepage: http://code.google.com/p/sunpinyin
Vcs-Git: git://git.debian.org/git/pkg-ime/sunpinyin
Vcs-Browser: http://git.debian.org/?p=pkg-ime/sunpinyin.git

Package: libsunpinyin-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsunpinyin3 (= ${binary:Version}), ${misc:Depends}, libsqlite3-dev
Description: Simplified Chinese Input Method from SUN (development)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains the development header files that allows others 
 to write their own front-end for sunpinyin.

Package: libsunpinyin3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Recommends: sunpinyin-data
Description: Simplified Chinese Input Method from SUN (runtime)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains the runtime library.

Package: libsunpinyin3-dbg
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libsunpinyin3 (= ${binary:Version})
Section: debug
Description: Simplified Chinese Input Method from SUN (debug)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains the debug symbols of shared library.

Package: python-sunpinyin
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, libsunpinyin3
Section: python
Description: Simplified Chinese Input Method from SUN (Python binding)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains the Python binding of sunpinyin.

Package: sunpinyin-utils
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python
Description: Simplified Chinese Input Method from SUN (utilities)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains some utilities used by open-gram project, 
 including:
 .
 genpyt - generate the pinyin lexicon
 tslmpack - convert the ARPA format of SunPinyin back-off language 
 model to its binary representation
 tslmendian - change the byte-order of sunpinyin's threaded back-off 
 language model
 .
 and some Python programs which maybe used to import user dictionary 
 from other input method such as sougou, google, fcitx etc.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
# Liang Guo <bluestonechina@gmail.com> 2010
# YunQiang Su <wzssyqa@gmail.com>, 2012

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

SCONS=scons 
POD2MAN=pod2man
PROGS=genpyt idngram_merge slminfo slmseg tslminfo getWordFreq ids2ngram \
      mmseg slmbuild slmprune slmthread tslmendian tslmpack

%:
	dh $@ --with python2

override_dh_auto_clean:
	dh_auto_clean
	scons -c .
	rm -rf .sconf_temp

override_dh_auto_build:
	$(SCONS)  --prefix=/usr --libdir=/usr/lib/${DEB_HOST_MULTIARCH}/ --libdatadir=/usr/lib/${DEB_HOST_MULTIARCH}
	for p in $(PROGS); do $(POD2MAN) --section 1 doc/$$p.pod > doc/$$p.1; done
	
override_dh_auto_install:
	$(SCONS) install --install-sandbox=debian/tmp
	for p in $(PROGS); do install -D -m 0755 build/$$p $(CURDIR)/debian/tmp/usr/bin/$$p; done

override_dh_install:
	dh_install --fail-missing
	rm -f debian/tmp/python-sunpinyin/usr/share/pyshared/sunpinyin/setup.py

override_dh_strip:
	dh_strip -plibsunpinyin3 --dbg-package=libsunpinyin3-dbg
	dh_strip

## sunpinyin 2.0.3+git20130507

=== SConstruct ===
--- 
+++ 
@@ -20,7 +20,7 @@
     'src/slm/slminfo/slminfo.cpp',
     'src/slm/sim_sen.cpp',
     'src/slm/sim_slm.cpp',
-    'src/slm/getWordFreq/getWordFreq.cpp',
+    'src/slm/getwordfreq/getwordfreq.cpp',
     'src/slm/slmseg/slmseg.cpp',
     'src/slm/thread/slmthread.cpp',
     'src/slm/thread/test_vc.cpp',
@@ -34,7 +34,7 @@
     'src/slm/sim_dict.cpp',
     'src/portability.cpp',
     'src/lexicon/trie_writer.cpp',
-    'src/lexicon/genPYT.cpp',
+    'src/lexicon/genpyt.cpp',
     'src/lexicon/pytrie_gen.cpp',
     'src/lexicon/pytrie.cpp',
     'src/pinyin/pinyin_data.cpp',
@@ -122,6 +122,45 @@
     'src/ime-core/imi_plugin.h',
     ]
 
+bins = [
+    'src/mmseg',
+    'src/slmseg',
+    'src/ids2ngram',
+    'src/idngram_merge',
+    'src/slmbuild',
+    'src/slmprune',
+    'src/slminfo',
+    'src/slmthread',
+    'src/tslmendian',
+    'src/tslminfo',
+    'src/tslmpack',
+    'src/genpyt',
+    'src/getwordfreq',
+    'src/sunpinyin-dictgen',
+    ]
+
+man1s = [
+    'man/mmseg.1',
+    'man/slmseg.1',
+    'man/ids2ngram.1',
+    'man/idngram_merge.1',
+    'man/slmbuild.1',
+    'man/slmprune.1',
+    'man/slminfo.1',
+    'man/slmthread.1',
+    'man/tslmendian.1',
+    'man/tslminfo.1',
+    'man/tslmpack.1',
+    'man/genpyt.1',
+    'man/getwordfreq.1',
+    ]
+
+docs = [
+    'doc/README',
+    'doc/SLM-train.mk',
+    'doc/SLM-inst.mk',
+    ]
+
 # options
 AddOption('--prefix', dest='prefix', metavar='DIR',
           help='installation prefix')
@@ -129,8 +168,8 @@
 AddOption('--libdir', dest='libdir', metavar='DIR',
           help='installation libdir')
 
-AddOption('--libdatadir', dest='libdatadir', metavar='DIR',
-          help='installation libdata dir')
+AddOption('--datadir', dest='datadir', metavar='DIR',
+          help='installation data dir')
 
 AddOption('--rpath', dest='rpath', metavar='DIR',
           help='encode rpath in the executables')
@@ -145,7 +184,7 @@
 opts = Variables('configure.conf')
 opts.Add('PREFIX', default='/usr/local')
 opts.Add('LIBDIR', default='/usr/local/lib')
-opts.Add('LIBDATADIR', default='/usr/local/lib')
+opts.Add('DATADIR', default='/usr/local/share')
 opts.Add('ENABLE_PLUGINS', default=False)
 
 #
@@ -162,25 +201,24 @@
     return platform.uname()[0]
 
 def CreateEnvironment():
-    tar = 'tar'
     make = 'make'
     wget = 'wget'
+    tar = 'tar'
     if GetOS() == 'Darwin':
         wget = 'curl -O'
     elif GetOS() == 'FreeBSD':
+        make = 'gmake'
         wget = 'fetch'
+    elif GetOS() == 'SunOS':
         make = 'gmake'
-    elif GetOS() == 'SunOS':
         tar = 'gtar'
-        make = 'gmake'
-
-    libln_builder = Builder(action='ln -s ${SOURCE.name} ${TARGET.name}',
-                            chdir=True)
-    env = Environment(ENV=os.environ, CFLAGS=cflags, CXXFLAGS=cflags,
-                      TAR=tar, MAKE=make, WGET=wget,
-                      CPPPATH=['.'] + allinc(),
-                      tools=['default', 'textfile'])
-    env.Append(BUILDERS={'InstallAsSymlink': libln_builder})
+    libln_builder = Builder(action='cd ${TARGET.dir} && ln -s ${SOURCE.name} ${TARGET.name}')
+    env = Environment(ENV = os.environ, CFLAGS = cflags, CXXFLAGS = cflags,
+                      MAKE = make, WGET = wget, TAR = tar,
+                      CPPPATH = ['.'] + allinc(),
+                      tools = ['default', 'textfile'])
+    env.Append(BUILDERS = {'InstallAsSymlink': libln_builder})
+    env['ENDIANNESS'] = "be" if sys.byteorder == "big" else "le"
     return env
 
 def PassVariables(envvar, env):
@@ -194,22 +232,26 @@
 
 if GetOption('prefix') is not None:
     env['PREFIX'] = GetOption('prefix')
-    env['LIBDATADIR'] = os.path.join(env['PREFIX'], 'lib')
     env['LIBDIR'] = os.path.join(env['PREFIX'], 'lib')
+    env['DATADIR'] = os.path.join(env['PREFIX'], 'share')
 
 if GetOption('libdir') is not None:
     env['LIBDIR'] = GetOption('libdir')
 
-if GetOption('libdatadir') is not None:
-    env['LIBDATADIR'] = GetOption('libdatadir')
+if GetOption('datadir') is not None:
+    env['DATADIR'] = GetOption('datadir')
 
 env['ENABLE_PLUGINS'] = GetOption('enable_plugins')
 
 opts.Save('configure.conf', env)
 
+bindir = os.path.join(env['PREFIX'], 'bin')
+mandir = os.path.join(env['PREFIX'], 'share/man')
+man1dir = os.path.join(mandir, 'man1')
+docdir = os.path.join(env['PREFIX'], 'share/doc/sunpinyin')
+headersdir = os.path.join(env['PREFIX'], 'include/sunpinyin-2.0')
+datadir = os.path.join(env['DATADIR'], 'sunpinyin')
 libdir = env['LIBDIR']
-libdatadir = os.path.join(env['LIBDATADIR'], 'sunpinyin/data')
-headersdir = os.path.join(env['PREFIX'], 'include/sunpinyin-2.0')
 
 # pass through environmental variables
 envvar = [('CC', 'CC'),
@@ -229,7 +271,7 @@
 
 # merge some of critical compile flags
 env.MergeFlags(['-pipe -DHAVE_CONFIG_H',
-                '-DSUNPINYIN_DATA_DIR=\\\'\\"%s\\"\\\'' % libdatadir])
+                '-DSUNPINYIN_DATA_DIR=\\\'\\"%s\\"\\\'' % datadir])
 
 if GetOption('rpath') is not None and GetOS() != 'Darwin':
     env.MergeFlags('-Wl,-R -Wl,%s' % GetOption('rpath'))
@@ -355,33 +397,5 @@
     # append endianness checking defines
     AppendEndianCheck(conf)
     env = conf.Finish()
-    # generate sunpinyin.pc
-    env.Substfile('sunpinyin-2.0.pc.in', SUBST_DICT={
-            '@PREFIX@': env['PREFIX'],
-            '@LIBDIR@': env['LIBDIR'],
-            '@VERSION@': version,
-            '@CFLAGS@': reduce(lambda a, b: a + ' ' + b,
-                               map(lambda x: '-I$${includedir}' + x[3:],
-                                   allinc())),
-            })
 
     if GetOS() != 'Darwin':
-        env.ParseConfig('pkg-config sqlite3 --libs --cflags')
-
-if not GetOption('clean') and not GetOption('help'):
-    DoConfigure()
-
-#
-#==============================compile==============================
-#
-env.Object(slmsource)
-
-SConscript(['build/SConscript'], exports='env')
-
-libname_default = '%ssunpinyin%s' % (env.subst('${SHLIBPREFIX}'),
-                                     env.subst('${SHLIBSUFFIX}'))
-libname_link = libname_default
-libname_soname = '%s.%d' % (libname_link, abi_major)
-libname = '%s.%d' % (libname_soname, abi_minor)
-lib = None
-

=== debian/changelog ===
sunpinyin (2.0.3+git20130507-1ubuntu1) trusty; urgency=low

  * Reintroduce aarch64 endian detection fix.

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 24 Nov 2013 15:29:45 -0700

sunpinyin (2.0.3+git20130507-1) unstable; urgency=low

  * New upstream snapshot 20130507.
     - Fix aarch64 endian check. (Closes: #727273)
     - Remove disable-lm-dict-compile.patch, merged into upstream
     - Binaries and manpages are installed automatic now
  * Use --datadir instead of --libdatadir now
  * Remove DMUA stantz.
  * Update Git URL to be canonical.

 -- YunQiang Su <wzssyqa@gmail.com>  Thu, 24 Oct 2013 18:13:41 +0800

sunpinyin (2.0.3+git20120404-1) unstable; urgency=medium

  * Medium urgency for fixing RC bug.
  * New upstream commit: fix FTBFS with gcc-4.7 (Closes: #667385).
  * Add Multi-Arch: same to libsunpinyin3, -dev and -dbg.
  * Add YunQiang Su to uploaders.

 -- YunQiang Su <wzssyqa@gmail.com>  Wed, 11 Apr 2012 03:06:40 +0800

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: sunpinyin
 Priority: optional
-Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
 Uploaders: Liang Guo <bluestonechina@gmail.com>, YunQiang Su <wzssyqa@gmail.com>
 Build-Depends: debhelper (>= 9), scons, libsqlite3-dev, pkg-config, 
 		quilt (>= 0.46-8~), python-dev (>= 2.6.6-3~)
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Section: libs
-DM-Upload-Allowed: yes
 Homepage: http://code.google.com/p/sunpinyin
-Vcs-Git: git://git.debian.org/git/pkg-ime/sunpinyin
-Vcs-Browser: http://git.debian.org/?p=pkg-ime/sunpinyin.git
+Vcs-Git: git://anonscm.debian.org/pkg-ime/sunpinyin.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/sunpinyin.git
 
 Package: libsunpinyin-dev
 Section: libdevel

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 SCONS=scons 
 POD2MAN=pod2man
-PROGS=genpyt idngram_merge slminfo slmseg tslminfo getWordFreq ids2ngram \
+PROGS=genpyt igetwordfreq dngram_merge slminfo slmseg tslminfo getWordFreq ids2ngram \
       mmseg slmbuild slmprune slmthread tslmendian tslmpack
 
 %:
@@ -19,12 +19,11 @@
 	rm -rf .sconf_temp
 
 override_dh_auto_build:
-	$(SCONS)  --prefix=/usr --libdir=/usr/lib/${DEB_HOST_MULTIARCH}/ --libdatadir=/usr/lib/${DEB_HOST_MULTIARCH}
-	for p in $(PROGS); do $(POD2MAN) --section 1 doc/$$p.pod > doc/$$p.1; done
+	$(SCONS)  --prefix=/usr --libdir=/usr/lib/${DEB_HOST_MULTIARCH}/ --datadir=/usr/lib/${DEB_HOST_MULTIARCH}
 	
 override_dh_auto_install:
 	$(SCONS) install --install-sandbox=debian/tmp
-	for p in $(PROGS); do install -D -m 0755 build/$$p $(CURDIR)/debian/tmp/usr/bin/$$p; done
+	rm -f debian/tmp/usr/bin/sunpinyin-dictgen
 
 override_dh_install:
 	dh_install --fail-missing

=== debian/watch ===
version=3
http://code.google.com/p/sunpinyin/downloads/list .*/sunpinyin-([0-9]\.*.*)\.tar\.gz

## sunpinyin 2.0.3+git20140127

=== debian/changelog ===
sunpinyin (2.0.3+git20140127-4) unstable; urgency=medium

  * Break & replace libsunpinyin3 to enable smothly 
    upgrade. 

 -- Liang Guo <guoliang@debian.org>  Wed, 14 Oct 2015 13:55:28 +0800

sunpinyin (2.0.3+git20140127-3) unstable; urgency=medium

  * Library rename for gcc-5 transition (Closes: #799651)
  * Fix formatting in description (Closes: #769793)

 -- Aron Xu <happyaron.xu@gmail.com>  Thu, 08 Oct 2015 13:47:10 +0800

sunpinyin (2.0.3+git20140127-2) unstable; urgency=medium

  * Team upload.
  * Fixed pod2man invocations. (Closes: #790287)
  * Acknowledge Chen Baozi's NMU.

 -- Guo Yixuan (郭溢譞) <culu.gyx@gmail.com>  Sun, 05 Jul 2015 15:20:03 -0400

sunpinyin (2.0.3+git20140127-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix aarch64 endian check. (Closes: #727273)

 -- Chen Baozi <baozich@debian.org>  Wed, 11 Feb 2015 12:34:59 +0000

sunpinyin (2.0.3+git20140127-1) unstable; urgency=low

  * New upstream snapshot 20140127
  * Update my mail address
  * Bump stardard version to 3.9.5

 -- Liang Guo <guoliang@debian.org>  Sat, 01 Mar 2014 15:22:47 +0800

=== debian/control ===
Source: sunpinyin
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Liang Guo <guoliang@debian.org>, YunQiang Su <wzssyqa@gmail.com>
Build-Depends: debhelper (>= 9), scons, libsqlite3-dev, pkg-config, 
		quilt (>= 0.46-8~), python-dev (>= 2.6.6-3~)
Standards-Version: 3.9.5
Section: libs
Homepage: http://code.google.com/p/sunpinyin
Vcs-Git: git://anonscm.debian.org/pkg-ime/sunpinyin.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/sunpinyin.git

Package: libsunpinyin-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsunpinyin3v5 (= ${binary:Version}), ${misc:Depends}, libsqlite3-dev
Description: Simplified Chinese Input Method from SUN (development)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains the development header files that allows others 
 to write their own front-end for sunpinyin.

Package: libsunpinyin3v5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libsunpinyin3
Replaces: libsunpinyin3
Pre-Depends: ${misc:Pre-Depends}
Recommends: sunpinyin-data
Description: Simplified Chinese Input Method from SUN (runtime)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains the runtime library.

Package: libsunpinyin3-dbg
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libsunpinyin3v5 (= ${binary:Version})
Section: debug
Description: Simplified Chinese Input Method from SUN (debug)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains the debug symbols of shared library.

Package: python-sunpinyin
Architecture: all
Depends: ${python:Depends}, ${misc:Depends}, libsunpinyin3v5
Section: python
Description: Simplified Chinese Input Method from SUN (Python binding)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains the Python binding of sunpinyin.

Package: sunpinyin-utils
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python
Description: Simplified Chinese Input Method from SUN (utilities)
 Sunpinyin is a statistical language model (SLM) based input method 
 engine for Simplified Chinese, it features full sentence input.
 .
 This package contains some utilities used by open-gram project, 
 including:
 .
  * genpyt - generate the pinyin lexicon
  * tslmpack - convert the ARPA format of SunPinyin back-off language 
    model to its binary representation
  * tslmendian - change the byte-order of sunpinyin's threaded back-off 
    language model
 .
 and some Python programs which maybe used to import user dictionary 
 from other input method such as sougou, google, fcitx etc.

=== debian/rules ===
--- 
+++ 
@@ -30,5 +30,5 @@
 	rm -f debian/tmp/python-sunpinyin/usr/share/pyshared/sunpinyin/setup.py
 
 override_dh_strip:
-	dh_strip -plibsunpinyin3 --dbg-package=libsunpinyin3-dbg
+	dh_strip -plibsunpinyin3v5 --dbg-package=libsunpinyin3-dbg
 	dh_strip

## sunpinyin 3.0.0~git20160910

=== debian/changelog ===
sunpinyin (3.0.0~git20160910-1) unstable; urgency=medium

  * New upstream snapshot 20160910
  * Refresh debian/copyright
  * Remove debian/patches/{strndup_in_cxx.patch, 
    detect-endianness-for-arm64.patch, pod2man.patch, gcc-6.patch},
    applied upstream
  * debian/docs, rename README to README.md
  * debian/control
    - Use secure uri in vcs-*
    - Update homepage
    - Bump Standards-Version to 3.9.8
  * Remove debian/watch
  * Remove debian/libsunpinyin3v5.postinst, work down by dh generated
    Trigger

 -- Liang Guo <guoliang@debian.org>  Thu, 13 Oct 2016 02:44:02 +0800

sunpinyin (2.0.3+git20140127-5) unstable; urgency=medium

  * Fix compile with gcc-6 by Rico Tzschichholz

 -- Aron Xu <aron@debian.org>  Sat, 06 Aug 2016 21:35:29 +0800

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,11 @@
 Uploaders: Liang Guo <guoliang@debian.org>, YunQiang Su <wzssyqa@gmail.com>
 Build-Depends: debhelper (>= 9), scons, libsqlite3-dev, pkg-config, 
 		quilt (>= 0.46-8~), python-dev (>= 2.6.6-3~)
-Standards-Version: 3.9.5
+Standards-Version: 3.9.8
 Section: libs
-Homepage: http://code.google.com/p/sunpinyin
-Vcs-Git: git://anonscm.debian.org/pkg-ime/sunpinyin.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/sunpinyin.git
+Homepage: https://github.com/sunpinyin
+Vcs-Git: https://anonscm.debian.org/git/pkg-ime/sunpinyin.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=pkg-ime/sunpinyin.git
 
 Package: libsunpinyin-dev
 Section: libdevel
